#include "StdAfx.h"
#include "MusicFile.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MMLfile*			MML			llkt@C̃IuWFNg
//		string				_code		NR[hi*.binj̃t@C
//		const		wchar_t	_strName[]	IuWFNg
//	Ԓl
//				
//==============================================================
MusicFile::MusicFile(MMLfile* MML, string _code, const wchar_t _strName[]):
	MusicItem(_strName),
	cDPCMinfo(NULL),
	Header(_code)
{
	//----------------------
	//Localϐ


//	萔`
enum	Command_ID_MusicFile {
	//for NSF output
	id_Title,
	id_Composer,
	id_Copyright,
	id_OffsetPCM,
	id_Code,
	id_External,
	id_Bank,

	//for ASM output
	id_SegmentSEQ,
	id_SegmentPCM,
	id_Label,
	id_Priority,

	//General
	id_include,
	id_timebase,
	id_OctaveReverse,
	id_bgm_num,
	id_se_num,
	id_offset_Ei,
	id_offset_Ev,
	id_offset_En,
	id_offset_Em,
	id_rest,
	id_wait,

	//Block
	id_DPCM,
	id_FDSC,
	id_FDSM,
	id_VRC7,
	id_N163,
	id_Envelop,
	id_Vibrato,
	id_Macro,
	id_Sub,
	id_BGM,
	id_SE,

	id_Null
};

//	́AMML\ŎgR}hB
const	static	Command_Info	Command[] = {
		//for NSF output
		{	"#Title",			id_Title		},
		{	"#title",			id_Title		},
		{	"Ȗ",				id_Title		},
		{	"#Composer",		id_Composer		},
		{	"#composer",		id_Composer		},
		{	"Ȏ",			id_Composer		},
		{	"",				id_Composer		},
		{	"#Copyright",		id_Copyright	},
		{	"#copyright",		id_Copyright	},
		{	"",				id_Copyright	},
		{	"쌠",			id_Copyright	},
		{	"#OffsetPCM",		id_OffsetPCM	},	//Offset Address of PCM
		{	"#offsetPCM",		id_OffsetPCM	},	//Offset Address of PCM
		{	"#offsetPCM",		id_OffsetPCM	},	//Offset Address of PCM
		{	"#Code",			id_Code			},
		{	"#code",			id_Code			},
		{	"R[h",			id_Code			},
		{	"#External",		id_External		},
		{	"#external",		id_External		},
		{	"#Bank",			id_Bank			},
		{	"#bank",			id_Bank			},
		{	"oN",			id_Bank			},
		//for ASM output
		{	"#SegmentPCM",		id_SegmentPCM	},	//Segment name for PCM
		{	"#segmentPCM",		id_SegmentPCM	},
		{	"#SegmentSEQ",		id_SegmentSEQ	},	//Segment name for Sequence
		{	"#segmentSEQ",		id_SegmentSEQ	},
		{	"#Segment",			id_SegmentSEQ	},	//Segment name for Sequence
		{	"#segment",			id_SegmentSEQ	},
		{	"#Label",			id_Label		},
		{	"#label",			id_Label		},

		//General
		{	"#Include",			id_include		},
		{	"#include",			id_include		},
		{	"ǂ",				id_include		},
		{	"#Timebase",		id_timebase		},
		{	"#timebase",		id_timebase		},
		{	"#OctaveReverse",	id_OctaveReverse},
		{	"#octaveReverse",	id_OctaveReverse},
		{	"#BGM",				id_bgm_num		},
		{	"#bgm",				id_bgm_num		},
		{	"y",			id_bgm_num		},
		{	"#SE",				id_se_num		},
		{	"#se",				id_se_num		},
		{	"ʉ",			id_se_num		},
		{	"#OffsetE@",		id_offset_Ei	},
		{	"#offsetE@",		id_offset_Ei	},
		{	"#OffsetEv",		id_offset_Ev	},
		{	"#offsetEv",		id_offset_Ev	},
		{	"#OffsetEm",		id_offset_Em	},
		{	"#offsetEm",		id_offset_Em	},
		{	"#OffsetEn",		id_offset_En	},
		{	"#offsetEn",		id_offset_En	},
		{	"#Priority",		id_Priority		},
		{	"#priority",		id_Priority		},
		{	"#Rest",			id_rest			},
		{	"#rest",			id_rest			},
		{	"#Wait",			id_wait			},
		{	"#wait",			id_wait			},
		//Block
		{	"DPCM",				id_DPCM			},
		{	"FDSC",				id_FDSC			},
		{	"FDSM",				id_FDSM			},
		{	"VRC7",				id_VRC7			},
		{	"N163",				id_N163			},
		{	"Envelope",			id_Envelop		},
		{	"envelope",			id_Envelop		},
		{	"Envelop",			id_Envelop		},
		{	"envelop",			id_Envelop		},
		{	"Gx[v",		id_Envelop		},
		{	"ru[g",		id_Vibrato		},
		{	"Sub",				id_Sub			},
		{	"sub",				id_Sub			},
		{	"BGM",				id_BGM			},
		{	"bgm",				id_BGM			},
		{	"y",				id_BGM			},
		{	"SE",				id_SE			},
		{	"se",				id_SE			},
		{	"ʉ",			id_SE			},

		//for 1 command
		{	"D",				id_DPCM			},
		{	"FC",				id_FDSC			},
		{	"FM",				id_FDSM			},
		{	"O",				id_VRC7			},
		{	"V",				id_VRC7			},
		{	"N",				id_N163			},
		{	"E",				id_Envelop		},
		{	"S",				id_Sub			},
		{	"$",				id_Macro		},

		//for mck/ppmck
		{	"@DPCM",			id_DPCM			},
		{	"@FM",				id_FDSC			},
		{	"@MW",				id_FDSM			},
		{	"@OP",				id_VRC7			},
		{	"@N",				id_N163			},
		{	"@E",				id_Envelop		},

		{	"@",				id_Null			},
	};

	unsigned	int			i;
	unsigned	char		cData;
				FDSC*		_fdsc;
				FDSM*		_fdsm;
				VRC7*		_vrc7;
				N163*		_n163;
				Envelop*	_env;
				BGM*		_bgm;
				SE*			_se;
				Sub*		_sub;
	string		msg;

	map<	int,	Envelop*	>::iterator	itEnvelop;
	map<	int,	BGM*		>::iterator	itBGM;
	map<	int,	SE*			>::iterator	itSE;
	map<	int,	Sub*		>::iterator	itSub;

	iSize = 0;

	do{
		
		//Pǂݍ݁iRg`FbNAincludet@C̏I[`FbNj
		cData = MML->GetChar();

		//[EOF]`FbN
		if( MML->eom() ){
			break;
		}

		//P߂
		MML->Back();

		//R}h̃`FbN
		switch(MML->GetCommandID(Command, sizeof(Command)/sizeof(Command_Info))){
			//for NSF output
			case(id_Code):
				Header.Set_RomCode(MML);
				break;
			case(id_Title):
				Header.Set_Title(MML);
				break;
			case(id_Composer):
				Header.Set_Composer(MML);
				break;
			case(id_Copyright):
				Header.Set_Copyright(MML);
				break;
			case(id_OffsetPCM):
				Header.Set_OffsetPCM(MML);
				break;
			case(id_External):
				Header.Set_External(MML);
				break;
			case(id_Bank):
				Header.Set_Bank();
				break;
			//for ASM output
			case(id_SegmentSEQ):
				Header.Set_SegmentSEQ(MML);
				break;
			case(id_SegmentPCM):
				Header.Set_SegmentPCM(MML);
				break;
			case(id_Label):
				Header.Set_Label(MML);
				break;
			//General
			case(id_include):
				MML->include();
				break;
			case(id_bgm_num):
				Header.Set_Number_BGM(MML);
				break;
			case(id_se_num):
				Header.Set_Number_SE(MML);
				break;
			case(id_timebase):
				MML->timebase = MML->GetInt();	//́AMMLt@C̑B
				break;
			case(id_OctaveReverse):
				MML->octave_reverse = true;		//́AMMLt@C̑B
				break;
			case(id_offset_Ei):
				MML->offset_Ei = MML->GetInt();
				break;
			case(id_offset_Ev):
				MML->offset_Ev = MML->GetInt();
				break;
			case(id_offset_En):
				MML->offset_En = MML->GetInt();
				break;
			case(id_offset_Em):
				MML->offset_Em = MML->GetInt();
				break;
			case(id_Priority):
				MML->priority = MML->GetInt();
				if((MML->priority<0) || (MML->priority>3)){
					MML->Err(L"#priorityR}h́A0`3͈̔͂Ŏw肵ĂB");
				}
				break;
			case(id_rest):
				MML->rest = MML->GetInt();
				if((MML->rest<0) || (MML->rest>2)){
					MML->Err(L"#RestR}h́A0`2͈̔͂Ŏw肵ĂB");
				}
				break;
			case(id_wait):
				MML->wait = MML->GetInt();
				if((MML->rest<0) || (MML->rest>2)){
					MML->Err(L"#WaitR}h́A0`2͈̔͂Ŏw肵ĂB");
				}
				break;
			//MML
			case(id_DPCM):
				if(cDPCMinfo != NULL){
					MML->Err(L"DPCMubN͂P܂łłB");
				}
				cDPCMinfo = new DPCMinfo(MML, Header.bank);
				ptcItem.push_back(cDPCMinfo);
				iSize += cDPCMinfo->getSize();	//BGM̃TCYXV
				break;
			case(id_FDSC):
				i = MML->GetNum();

				//d`FbN
				if(ptcFDSC.count(i) != 0){
					MML->Err(L"FDSC()ubNœԍw肳܂B");
				}
				_fdsc = new FDSC(MML, i);
				ptcItem.push_back(_fdsc);
				ptcFDSC[i] = _fdsc;
				iSize += _fdsc->getSize();	//BGM̃TCYXV
				break;
			case(id_FDSM):
				i = MML->GetNum();

				//d`FbN
				if(ptcFDSM.count(i) != 0){
					MML->Err(L"FDSM()ubNœԍw肳܂B");
				}
				_fdsm = new FDSM(MML, i);
				ptcItem.push_back(_fdsm);
				ptcFDSM[i] = _fdsm;
				iSize += _fdsm->getSize();	//BGM̃TCYXV
				break;
			case(id_VRC7):
				i = MML->GetNum();

				//d`FbN
				if(ptcVRC7.count(i) != 0){
					MML->Err(L"VRC7()ubNœԍw肳܂B");
				}
				_vrc7 = new VRC7(MML, i);
				ptcItem.push_back(_vrc7);
				ptcVRC7[i] = _vrc7;
				iSize += _vrc7->getSize();	//BGM̃TCYXV
				break;
			case(id_N163):
				i = MML->GetNum();

				//d`FbN
				if(ptcN163.count(i) != 0){
					MML->Err(L"N163()ubNœԍw肳܂B");
				}
				_n163 = new N163(MML, i);
				ptcItem.push_back(_n163);
				ptcN163[i] = _n163;
				iSize += _n163->getSize();	//BGM̃TCYXV
				break;
			case(id_Envelop):
				i = MML->GetNum();
				//d`FbN
				if(ptcEnv.count(i) != 0){
					MML->Err(L"Envelope()ubNœԍw肳܂B");
				}
				_env = new Envelop(MML, i);
				ptcItem.push_back(_env);
				ptcEnv[i] = _env;
				iSize += _env->getSize();	//BGM̃TCYXV
				break;
			case(id_Vibrato):
				MML->offset_Em = 1000000;
				i = MML->GetNum() + MML->offset_Em;
				//d`FbN
				if(ptcEnv.count(i) != 0){
					MML->Err(L"ru[g()ubNœԍw肳܂B");
				}
				_env = new Envelop(MML, i);
				ptcItem.push_back(_env);
				ptcEnv[i] = _env;
				iSize += _env->getSize();	//BGM̃TCYXV
				break;
			case(id_Macro):
				MML->SetMacro();
				break;
			case(id_Sub):
				i = MML->GetNum();
				//d`FbN
				if(ptcSub.count(i) != 0){
					MML->Err(L"Sub()ubNœԍw肳܂B");
				}
				//͈̓`FbN
				_sub = new Sub(MML, i);
				ptcItem.push_back(_sub);
				ptcSub[i] = _sub;
				iSize += _sub->getSize();	//BGM̃TCYXV
				break;
			case(id_BGM):
				i = MML->GetNum();
				//d`FbN
				if(ptcBGM.count(i) != 0){
					MML->Err(L"BGM()ubNœԍw肳܂B");
				}
				//͈̓`FbN
				if((Header.iBGM <= i) || (i<0)){
					MML->Err(L"BGM()ubNŎwł͈͂𒴂Ă܂B\n#BGM̐lmFĂB");
				}
				_bgm = new BGM(MML, i);
				ptcItem.push_back(_bgm);
				ptcBGM[i] = _bgm;
				iSize += _bgm->getSize();	//BGM̃TCYXV
				break;
			case(id_SE):
				i = MML->GetNum();
				//d`FbN
				if(ptcSE.count(i) != 0){
					MML->Err(L"SE()ubNœԍw肳܂B");
				}
				//͈̓`FbN
				if((Header.iSE <= i) || (i<0)){
					MML->Err(L"SE()ubNŎwł͈͂𒴂Ă܂B\n#SE̐lmFĂB");
				}
				_se = new SE(MML, i);
				ptcItem.push_back(_se);
				ptcSE[i] = _se;
				iSize += _se->getSize();	//BGM̃TCYXV
				break;
			case(id_Null):
				break;
			default:
				MML->Err(L"unknown command");
				break;
		}
		
	} while( !MML->eom() );

	//Check
	if( Header.iBGM + Header.iSE > 255){
		Err(L"BGMSE̐v255z܂B");
	}

	i = 0;
	while(i < Header.iBGM){
		if(ptcBGM.count(i) == 0){
			Err(L"BGMf[^܂B");
		};
		i++;
	}

	i = 0;
	while(i < Header.iSE){
		if(ptcSE.count(i) == 0){
			Err(L"SE f[^܂B");
		};
		i++;
	}

}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
MusicFile::~MusicFile(void)
{
}

//==============================================================
//		PCM̃ItZbgAhXvZ
//--------------------------------------------------------------
//	
//		unsigned	int	iMusSize	V[PX̃TCY
//	Ԓl
//		unsigned	int	PCM̍vTCY
//==============================================================
unsigned	int		MusicFile::SetDPCMOffset(unsigned int iMusSize)
{
	unsigned	int		i;
	unsigned	char	mus_bank = (unsigned char)(iMusSize >> 12);

	if((iMusSize & 0x0FFF) != 0){
		mus_bank++;
	}


	dpcm_code.clear();
	if(cDPCMinfo != NULL){
		cDPCMinfo->getDPCMCode(&dpcm_code);
		i = cDPCMinfo->setDPCMoffset(Header.offsetPCM, mus_bank+3);
	} else {
		i = Header.offsetPCM;
	}
	return(i - Header.offsetPCM);
}

//==============================================================
//		AhX肷B
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicFile::Fix_Address(void)
{
	map<int,Sub*	>::iterator	itSub;

	unsigned	int			iBGM	= 0;
	unsigned	int			iSE		= 0;

	while(iBGM < Header.iBGM){
		ptcBGM[iBGM]->Fix_Address(this);
		iBGM++;
	}
	while(iSE < Header.iSE){
		ptcSE[iSE]->Fix_Address(this);
		iSE++;
	}

	if(!ptcSub.empty()){
		itSub = ptcSub.begin();
		while(itSub != ptcSub.end()){
			itSub->second->Fix_Address(this);
			itSub++;
		}
	}
}

/*
//==============================================================
//		ȃoCiC[W̍쐬
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicFile::make_binary(void)
{

}
*/		
//==============================================================
//		mre̍쐬
//--------------------------------------------------------------
//	
//		size_t	rom_size	*.biñTCY
//	Ԓl
//				
//==============================================================
void	MusicFile::make_bin(size_t rom_size, int ptOffset)
{
				string		_str;
	unsigned	int			i		= 2;
	unsigned	int			iBGM	= 0;
	unsigned	int			iSE		= 0;
	unsigned	short*		pt;

				size_t		_size	= 4 + (Header.iBGM + Header.iSE)*2;


	//ȃoCi[̍쐬
	_str.clear();
	_str.resize(_size);

	pt = (unsigned short*)_str.c_str();

	_str[0] = Header.iBGM;
	_str[1] = Header.iSE;

	if(Header.bank == false){

		if(cDPCMinfo != NULL){
			pt[1]	= ptOffset + (unsigned short)rom_size - 0x80 + (unsigned short)_size + (unsigned short)cDPCMinfo->getOffset();	//PCM info ̃AhX
		} else {
			pt[1]	= 0;
		}

		while(iBGM < Header.iBGM){
			pt[i] = ptOffset + (unsigned short)rom_size - 0x80 + (unsigned short)_size + (unsigned short)ptcBGM[iBGM]->getOffset();
			i++;
			iBGM++;
		}
		while(iSE < Header.iSE){
			pt[i] = ptOffset + (unsigned short)rom_size - 0x80 + (unsigned short)_size + (unsigned short)ptcSE[iSE]->getOffset();
			i++;
			iSE++;
		}

	} else {

		if(cDPCMinfo != NULL){
			pt[1]	= ptOffset + (unsigned short)_size + (unsigned short)cDPCMinfo->getOffset();	//PCM info ̃AhX
		} else {
			pt[1]	= 0;
		}

		while(iBGM < Header.iBGM){
			pt[i] = ptOffset + (unsigned short)_size + (unsigned short)ptcBGM[iBGM]->getOffset();
			i++;
			iBGM++;
		}
		while(iSE < Header.iSE){
			pt[i] = ptOffset + (unsigned short)_size + (unsigned short)ptcSE[iSE]->getOffset();
			i++;
			iSE++;
		}

	}

	getCode(&_str);
	code = _str;

	//PCM̍쐬
	dpcm_code.clear();
	if(cDPCMinfo != NULL){
		cDPCMinfo->getDPCMCode(&dpcm_code);
	}

}

//==============================================================
//		mre`ւ̕ۑ
//--------------------------------------------------------------
//	
//		const	char*	strFileName		t@C
//		bool			opt				œKtO
//	Ԓl
//				
//==============================================================
void	MusicFile::saveNSF(const char*	strFileName,bool opt)
{

	unsigned	int		i,j;
				size_t	bin_size;
				size_t	mus_size;
				size_t	pcm_size;
	unsigned	char	mus_bank;
	unsigned	char	pcm_bank;
				char*	romimg		= new char[0xC000+0x80];
	NSF_Header*			nsf			= (NSF_Header*)romimg;
	FileInput*			_romcode	= new FileInput();
				bool	dpcm_bank	= false;
				int		iSizeLimit;

	//NSFpR[h̓]
	_romcode->fileopen(Header.romcode.c_str());
	bin_size = _romcode->GetSize();
	_romcode->read(romimg, bin_size);
	_romcode->close();
	delete		_romcode;

	//NSFwb_[̍XV
	memcpy(&nsf->Title, Header.title.c_str(), 32);
	memcpy(&nsf->Composer, Header.composer.c_str(), 32);
	memcpy(&nsf->Copyright, Header.copyright.c_str(), 32);
	nsf->MusicNumber	= Header.iBGM + Header.iSE;
	if(Header.iExternal != -1){
		nsf->External	= (unsigned char)Header.iExternal;
	}

	wcout << L"--------------------" << endl;
	wcout << L"*NSF build process" << endl;


	if((nsf->Bank[0] == 0) && (nsf->Bank[1] == 0) && (nsf->Bank[2] == 0) && (nsf->Bank[3] == 0)){

		//------------------------------
		//Bank Ήbin

		//V[PX̃oCi𐶐
		make_bin(bin_size, 0x8000);

		if(Header.bank == true){
			wcout << L"w.bint@ĆAPCM̃oNɑΉĂ܂B" << endl;
			wcout << L"PCM̃oNɑΉ.bint@Cw肵ĂB" << endl;
			exit(-1);
		}

		mus_size = bin_size - 0x80 + code.size();
		mus_bank = (unsigned char)(mus_size >> 12);
		if((mus_size & 0x0FFF) != 0){
			mus_bank++;
		}

		//TCY`FbN
		wcout << L"[CODE & MUSIC]" << endl;
		wcout << L"  Bank = " << (unsigned int)mus_bank << endl;
		wcout << L"  Size = " << (unsigned int)mus_size << L" [Byte] / " << Header.offsetPCM - 0x8000 << L" [Byte]" << endl;

		if((0x8000 + mus_size) > Header.offsetPCM){
			wcout << L"R[hEV[PX̃TCYelz܂B" << endl;
			exit(-1);
		}

	} else {

		//------------------------------
		//BankΉbinH

		//V[PX̃oCi𐶐
		make_bin(bin_size, 0x0000);
		iSizeLimit = 0x10000;	//gRAMւ̓]L

		if(Header.bank == false){
			wcout << L"w.bint@ĆAPCM̃oNɑΉĂ܂B" << endl;
			wcout << L"#BankR}hw肵ĂB" << endl;
			exit(-1);
		}

		dpcm_bank = true;
		mus_size = code.size();
		mus_bank = (unsigned char)(mus_size >> 12);
		if((mus_size & 0x0FFF) != 0){
			mus_bank++;
		}

		wcout << L"[CODE]" << endl;
		wcout << L"  Bank = 2 + 1" << endl;
		wcout << L"  Size = 8192 + 4096 [Byte]" << endl;

		wcout << L"[MUSIC]" << endl;
		wcout << L"  Bank = " << (unsigned int)mus_bank << endl;
		wcout << L"  Size = " << (unsigned int)mus_size << L" [Byte] / " << iSizeLimit << L" [Byte]" << endl;

		//TCY`FbN
		if(mus_size > iSizeLimit){
			wcout << L"R[hEV[PX̃TCYelz܂B" << endl;
			exit(-1);
		}

	}

	//PCM
	wcout << L"[DPCM]" << endl;

	pcm_size = dpcm_code.size();
	pcm_bank = (unsigned char)((pcm_size + (Header.offsetPCM & 0x0FFF)) >> 12);
	if((pcm_size & 0x0FFF) != 0){
		pcm_bank++;
	}


	if(dpcm_bank == false){
		//PCMTCY`FbN
		wcout << L"  Bank = " << (unsigned int)pcm_bank << endl;
		wcout << L"  Size = " << (unsigned int)pcm_size << L" [Byte] / " << 0x10000 - Header.offsetPCM << L" [Byte]" << endl;

		if(	(Header.offsetPCM + pcm_size) > 0x10000	){
			wcout << L"PCM̃TCYelz܂B" << endl;
			exit(-1);
		}

	} else {
		//PCMTCY`FbN
		wcout << L"  Bank = " << (unsigned int)pcm_bank << endl;
		wcout << L"  Size = " << (unsigned int)pcm_size << L" [Byte]" << endl;

		i = mus_bank + pcm_bank + 3;
		if(i > 255){
			wcout << L"oN255z܂B" << endl;
			wcout << L"@oNʁF" << i << L"[Bank]" << endl;
			exit(-1);
		}
	}

	//----------------------
	//mre
	fileopen(strFileName);

	if(dpcm_bank == false){
		if(cDPCMinfo == NULL){
			//PCMgȂꍇ
			write(romimg, bin_size);			//NSFwb_[  R[h̏
			write(code.c_str(), code.size());	//V[PX̏

		} else {
			//PCMgꍇ
			if(opt == true){
				//œKLł΁Awb_[ɃoNB
				i = 0;
				while(i < mus_bank){
					nsf->Bank[i] = (unsigned char)i;
					i++;
				}
				while(i < ((Header.offsetPCM - 0x8000)>>12)){
					nsf->Bank[i] = 0;
					i++;
				}
				j = 0;
				while(i < 8){
					if(j < pcm_bank){
						nsf->Bank[i] = mus_bank + (unsigned char)j;
					} else {
						nsf->Bank[i] = 0;
					}
					i++;
					j++;
				}
			}

			//R[hV[PX
			write(romimg, bin_size);			//NSFwb_[  R[h̏
			write(code.c_str(), code.size());	//V[PX̏

			if(opt == true){
				//GAP
				while(mus_size < ((unsigned int)mus_bank<<12)){
					put(0);		//0 padding
					mus_size++;
				}
				//GAP2
				mus_size = Header.offsetPCM & 0x0FFF;
				while(mus_size > 0 ){
					put(0);		//0 padding
					mus_size--;
				}
				//PCM
				write(dpcm_code.c_str(), pcm_size);		//PCM̏
				while(pcm_size < ((unsigned int)pcm_bank<<12)){
					put(0);		//0 padding
					pcm_size++;
				}
			} else {
				//GAP
				while(mus_size < (Header.offsetPCM - 0x8000)){
					put(0);		//0 padding
					mus_size++;
				}
				//PCM
				write(dpcm_code.c_str(), pcm_size);		//PCM̏
			}
		}
	} else {
		//Bank Ήbin
		write(&romimg[0x0000], bin_size);	//NSFwb_[  R[h̏
		write(code.c_str(), code.size());	//V[PX̏
		//GAP
		while(mus_size < ((unsigned int)mus_bank<<12)){
			put(0);		//0 padding
			mus_size++;
		}

		write(dpcm_code.c_str(), pcm_size);		//PCM̏
		//GAP
		while(pcm_size < ((unsigned int)pcm_bank<<12)){
			put(0);		//0 padding
			pcm_size++;
		}

		if(opt != true){
			//GAPiKA32kByteȏɂBj
			i = (mus_bank + pcm_bank + 3) << 12;
			while(i < 0x8000){
				put(0);		//0 padding
				i++;
			}
		}

	}

	close();

	//----------------------
	//Exit
	delete[]	romimg;
}

//==============================================================
//		AZu\[Xւ̕ۑ
//--------------------------------------------------------------
//	
//		const	char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
void	MusicFile::saveASM(const char*	strFileName)
{
	unsigned	int			iBGM	= 0;
	unsigned	int			iSE		= 0;

	//----------------------
	//File open
	fileopen(strFileName);

	//Header
	*this <<	";===============================================================\n"
				";		Music file for NES Sound Driver & Library\n"
				";			for assembly language (ca65.exe)\n"
				";===============================================================\n"
				<<endl;

	//Export of Sequence
	while(iBGM < Header.iBGM){
		*this	<<	"	.export		"	<<	Header.Label	<<	"BGM"	<<	iBGM	<<	endl;
		iBGM++;
	}
	while(iSE < Header.iSE){
		*this	<<	"	.export		"	<<	Header.Label	<<	"SE"	<<	iSE	<<	endl;
		iSE++;
	}

	if(cDPCMinfo != NULL){
		*this	<<	"	.export		"	<<	Header.Label	<<	"DPCMinfo"	<<	endl;
	}

	//MML
	*this <<	"\n\n.segment	"	<<	'"'	<<	Header.segmentSEQ	<<	'"' << endl;

	getAsm(this);

	//----------------------
	//Close file
	close();
}

//==============================================================
//		G[
//--------------------------------------------------------------
//	
//		const	wchar_t	msg[]	G[bZ[W
//	Ԓl
//				
//==============================================================
void	MusicFile::Err(const wchar_t msg[])
{
	wcout << L"[ ERROR ] : " << msg << endl;

	//ُI
	exit(-1);
}

//==============================================================
//		[jO
//--------------------------------------------------------------
//	
//		const	wchar_t	msg[]	[jObZ[W
//	Ԓl
//				
//==============================================================
void	MusicFile::Warning(const wchar_t msg[])
{
	//݂̃t@CƁAs\
	wcout << L"[WARNING] : " << msg << endl;
}
